Attribute VB_Name = "Module1"
Option Explicit

Public Const SW_SHOWNORMAL = 1
Public Const ERROR_SUCCESS = 0&
Public Const SYNCHRONIZE = &H100000

Public Const STANDARD_RIGHTS_ALL = &H1F0000
Public Const KEY_QUERY_VALUE = &H1
Public Const KEY_SET_VALUE = &H2
Public Const KEY_CREATE_SUB_KEY = &H4
Public Const KEY_ENUMERATE_SUB_KEYS = &H8
Public Const KEY_NOTIFY = &H10
Public Const KEY_CREATE_LINK = &H20

Public Const KEY_ALL_ACCESS = ((STANDARD_RIGHTS_ALL Or KEY_QUERY_VALUE _
Or KEY_SET_VALUE Or KEY_CREATE_SUB_KEY Or KEY_ENUMERATE_SUB_KEYS Or _
KEY_NOTIFY Or KEY_CREATE_LINK) And (Not SYNCHRONIZE))

Public Const REG_SZ = 1
Public Const HKEY_LOCAL_MACHINE = &H80000002
Public Const INFINITE = &HFFFF           '  Infinite timeout

Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long
Declare Function RegOpenKeyEx Lib "advapi32.dll" Alias "RegOpenKeyExA" _
(ByVal hKey As Long, ByVal lpSubKey As String, ByVal ulOptions As Long, _
ByVal samDesired As Long, phkResult As Long) As Long
Declare Function RegSetValueEx Lib "advapi32.dll" Alias "RegSetValueExA" _
(ByVal hKey As Long, ByVal lpValueName As String, ByVal reserved As _
Long, ByVal dwType As Long, lpData As Any, ByVal cbData As Long) As Long
Declare Function RegQueryValueEx Lib "advapi32.dll" Alias _
"RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, _
ByVal lpReserved As Long, lpType As Long, lpData As Any, lpcbData As _
Long) As Long
Declare Function GetLastError Lib "kernel32" () As Long


Public Declare Function OpenProcess Lib "kernel32" (ByVal _
dwDesiredAccess As Long, ByVal bInheritHandle As Long, ByVal dwProcessId _
As Long) As Long
Public Declare Function CloseHandle Lib "kernel32" (ByVal hObject As _
Long) As Long
Public Declare Function WaitForSingleObject Lib "kernel32" (ByVal _
hHandle As Long, ByVal dwMilliseconds As Long) As Long

Declare Function GetPrivateProfileString Lib "kernel32" Alias _
"GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal _
lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As _
String, ByVal nSize As Long, ByVal lpFileName As String) As Long



Public Function GetSystemDB() As String

Dim keyHwnd As Long
Dim lRetValue As Long

Dim sValue As String
Dim lValueLen As Long
Dim lValueType As Long

Dim sRegistryKey As String
Dim sRegistryValue As String

sRegistryKey = "SOFTWARE\Microsoft\Jet\4.0\Engines" ' You may need to change this on your system. Check your registry entry for JET
sRegistryValue = "SystemDB"

lRetValue = RegOpenKeyEx(HKEY_LOCAL_MACHINE, sRegistryKey, 0, _
KEY_ALL_ACCESS, keyHwnd)

If lRetValue <> 0 Then
    MsgBox "Microsoft Access Entry not found.", 48, "Registry Failure"
    Exit Function
End If

sValue = String$(512, 0)
' lValueLen = 512 ' - Uncomment this line to fix

lRetValue = RegQueryValueEx(keyHwnd, sRegistryValue, 0&, lValueType, _
sValue, lValueLen)

' lRetValue = RegQueryValueEx(keyHwnd, sRegistryValue, 0&, lValueType, _
' ByVal sValue, lValueLen)

If lRetValue = ERROR_SUCCESS Then
    MsgBox "Current System Database: " & Chr(13) & sValue
    GetSystemDB = sValue
Else
    MsgBox "Unable to obtain system database value in register.", 48, _
"Registry Failure - Function Returned: " & CStr(lRetValue)

End If

lRetValue = RegCloseKey(keyHwnd)

End Function

