VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "dwCheapTrace"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' Copyright  1996-2003 by Desaware. All Rights Reserved
' Part of the Desaware API Class Library
' CheapTrace support
Option Explicit

Private TraceWndHandle As Long


'**********************************
'**  Function Declarations:

Private Declare Function FindWindow Lib "user32" Alias "FindWindowA" (ByVal lpClassName As String, ByVal lpWindowName As String) As Long
Private Declare Function GetWindow Lib "user32" (ByVal hWnd As Long, ByVal wCmd As Long) As Long
Private Declare Function IsWindow Lib "user32" (ByVal hWnd As Long) As Long
Private Declare Function SendMessageByString Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As String) As Long



'**********************************
'**  Constant Definitions:
Private Const WM_USER& = &H400

Private Const GW_CHILD& = 5
Private Const LB_ADDSTRING = &H180




Private Sub SetTraceWindow()
    Dim FormWindow&
    FormWindow = FindWindow(vbNullString, "CheapTrace")
    If IsWindow(FormWindow) <> 0 Then
        TraceWndHandle = GetWindow(FormWindow, GW_CHILD)
    End If
End Sub

' Add a trace message to the cheap trace viewer
Public Sub TraceMessage(ByVal msg As String)
    If IsWindow(TraceWndHandle) = False Then
        SetTraceWindow
        If IsWindow(TraceWndHandle) = False Then Exit Sub
    End If
    Call SendMessageByString(TraceWndHandle, LB_ADDSTRING, 0, msg)
End Sub
